/*
** example.c
** 
** Made by mayhem
** 
** Last update Sat Nov 10 03:52:57 2001 mayhem
*/
#include "lkh.c"




int	hijack_me(int a, int b);
int	hijack_zero(void *ptr);
int	hijack_one(void *ptr);
int	hijack_two(void *ptr);
void	hijack_fork(void *ptr);
void	hijack_schedule(void *ptr);



static  hook_t	*h = NULL;
static  hook_t	*i = NULL;
static  hook_t	*j = NULL;







/*
** MAIN FUNCTION OF THE USERLAND CODE
*/
int		init_module()
{
  int		ret;


  //printk(KERN_ALERT "Change the SYS_FORK function before ! \n");
  //return (-1);

  /*
  ** Create the hooks
  */
  h = khook_create(ksym_lookup("hijack_me"), HOOK_PERMANENT  | HOOK_ENABLED | HOOK_AGGRESSIVE);
  i = khook_create(ksym_lookup("schedule") , HOOK_SINGLESHOT | HOOK_ENABLED | HOOK_DISCRETE);

#define	SYS_FORK 0xc010584c
  j = khook_create(SYS_FORK, HOOK_PERMANENT | HOOK_ENABLED | HOOK_DISCRETE);
#undef	SYS_FORK



  /*
  ** Yet another check
  */
  if (!h || !i || !j)
    {
      printk(KERN_ALERT "Cannot hook kernel functions \n");
      return (-1);
    }


  /*
  ** Adding some callbacks for the sys_fork and schedule functions
  */
  khook_add_entry(i, (int) hijack_schedule, 0);
  khook_add_entry(j, (int) hijack_fork, 0);



  /*
  ** Testing the hijack_me() hook .
  */
  printk(KERN_ALERT "Testing a permanent, aggressive, enabled hook with 3 callbacks:\n");
  khook_add_entry(h, (int) hijack_zero, 1);
  khook_add_entry(h, (int) hijack_one, 0);
  khook_add_entry(h, (int) hijack_two, 2);
  ret = hijack_me(0, 1);

  printk(KERN_ALERT "--------------------\n");
  printk(KERN_ALERT "Testing a disabled hook :\n");
  khook_set_state(h, HOOK_DISABLED);
  ret = hijack_me(10, 20);

  khook_destroy(h);
  printk(KERN_ALERT "------------------\n");
  printk(KERN_ALERT "Calling hijack_me after the hook destruction\n");
  hijack_me(1, 2);

  return (0);
}



void	cleanup_module()
{
  khook_destroy(i);
  khook_destroy(j);
  printk(KERN_ALERT "LKH unloaded .::. sponsorized by the /dev/hell crew ! \n");
}













/*
** Function to hijack
*/
int	hijack_me(int a, int b)
{
  printk(KERN_ALERT "A in HIJACKME!!! = %u \t -OK- \n", a);
  printk(KERN_ALERT "B in HIJACKME!!! = %u \t -OK- \n", b);
  return (42);
}



/*
** First callback
*/
int	hijack_zero(void *ptr)
{
  int	*a;
  int	*b;

  a = ptr;
  b = a + 1;
  printk(KERN_ALERT "A in hijack_zero = %u \t -OK- \n", *a);
  printk(KERN_ALERT "B in hijack_zero = %u \t -OK- \n", *b);
  (*b)++;
  (*a)++;
  return (0);
}



/*
** Second callback
*/
int	hijack_one(void *ptr)
{
  int	*a;
  int	*b;
  
  a = ptr;
  b = a + 1;
  printk(KERN_ALERT "A in hijack_one  = %u \t -OK- \n", *a);
  printk(KERN_ALERT "B in hijack_one  = %u \t -OK- \n", *b);
  (*a)++;
  (*b)++;
  return (1);
}



/*
** Third callback
*/
int	hijack_two(void *ptr)
{
  int	*a;
  int	*b;

  a = ptr;
  b = a + 1;
  printk(KERN_ALERT "A in hijack_two  = %u \t -OK- \n", *a);
  printk(KERN_ALERT "B in hijack_two  = %u \t -OK- \n", *b);
  (*a)++;
  (*b)++;
  return (2);
}




/*
** Callbacks for sys_fork() and schedule()
*/
void	hijack_fork(void *ptr)
{
  printk(KERN_ALERT "FORKING! \n");
}

void	hijack_schedule(void *ptr)
{
  printk(KERN_ALERT "SCHEDULING! \n");
}








































